package cn.wustlinghang.wusthelper.internal.undergrad.api.json;

import cn.wustlinghang.mywust.core.parser.undergraduate.UndergradCourseTableParser;
import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradCourseTableApiService;
import cn.wustlinghang.mywust.data.global.Course;
import cn.wustlinghang.mywust.data.global.StudentInfo;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.wusthelper.rpc.response.RpcResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;
import java.util.List;

@Path("/course_table")
@ApplicationScoped
public class CourseTableApi {
    private final UndergradCourseTableApiService studentInfoApiService;
    private final UndergradCourseTableParser studentInfoPageParser;

    public CourseTableApi(UndergradCourseTableApiService studentInfoApiService,
                          UndergradCourseTableParser studentInfoPageParser) {
        this.studentInfoApiService = studentInfoApiService;
        this.studentInfoPageParser = studentInfoPageParser;
    }

    @GET
    @Path("/")
    public List<Course> get(@QueryParam("cookie") @NotNull String cookie, @QueryParam("term") String term)
            throws IOException, ApiException, ParseException {
        String html = studentInfoApiService.getPage(term, cookie);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie, @QueryParam("term") String term)
            throws IOException, ApiException {
        return studentInfoApiService.getPage(term, cookie);
    }

    @POST
    @Path("/parse")
    public List<Course> parse(String html) throws ParseException {
        return studentInfoPageParser.parse(html);
    }
}
