package cn.wustlinghang.wusthelper.internal.undergrad.services;

import cn.wustlinghang.mywust.core.request.service.undergraduate.*;
import cn.wustlinghang.mywust.exception.ApiException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class RequestAgentService {
    private final UndergradCourseTableApiService courseTableApiService;
    private final UndergradScoreApiService scoreApiService;
    private final UndergradStudentInfoApiService studentInfoApiService;
    private final UndergradTrainingPlanApiService trainingPlanApiService;
    private final UndergradCreditStatusApiService creditStatusApiService;
    private final UndergradExamDelayApiService examDelayApiService;

    public RequestAgentService(UndergradCourseTableApiService courseTableApiService,
                               UndergradScoreApiService scoreApiService,
                               UndergradStudentInfoApiService studentInfoApiService,
                               UndergradTrainingPlanApiService trainingPlanApiService,
                               UndergradCreditStatusApiService creditStatusApiService,
                               UndergradExamDelayApiService examDelayApiService) {

        this.courseTableApiService = courseTableApiService;
        this.scoreApiService = scoreApiService;
        this.studentInfoApiService = studentInfoApiService;
        this.trainingPlanApiService = trainingPlanApiService;
        this.creditStatusApiService = creditStatusApiService;
        this.examDelayApiService = examDelayApiService;
    }

    public String getStudentInfoPage(String cookie) throws IOException, ApiException {
        return studentInfoApiService.getPage(cookie);
    }

    public String getCourseTable(String cookie, String term) throws IOException, ApiException {
        return courseTableApiService.getPage(term, cookie);
    }

    public String getScore(String cookie) throws IOException, ApiException {
        return scoreApiService.getPage(cookie);
    }

    public String getTrainingPlan(String cookie) throws IOException, ApiException {
        return trainingPlanApiService.getPage(cookie);
    }

    public String getCreditStatus(String cookie) throws IOException, ApiException {
        return creditStatusApiService.getPage(cookie, null, false);
    }

    public UndergradExamDelayApiService.ExamActivity[] getExamActivities(String cookie, String term)
            throws IOException, ApiException {
        return examDelayApiService.getActivities(term, cookie);
    }

    public String getExamDelayApplications(String cookie, String term, String activityId)
            throws IOException, ApiException {
        return examDelayApiService.getPage(term, activityId, cookie);
    }
}
